<?php
/**	
 *
 *	GLOBALS CLASS
 *	Author: Paul Hamlington
 *	Purpose: Store all site globals that are variables. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;
	

    /** [ GLOBALS CLASS ] */
    class globals
        {
        /** [ CONSTANT PROPERTIES ] */
        const LICENSE_KEY              = 'F6Gc0ldqLN21DbTdSyh1';
        const LICENSE_URL              = 'https://www.qiq.support/';
        const LICENSE_CHECKDAYS        = 30;
        const LICENSE_FAILDAYS         = 5;
        const PLUGIN_NAME              = 'Modulized: Docsaway';
	    const PLUGIN_ID                = 'modulized_docsaway';
        const DOCSAWAY_URL             = 'https://www.docsaway.com';
        const BASE_CURRENCY            = 'GBP';
        const CRYPT_KEY                = 'H1VdFuAvtBkTh8FvROgmcGon';
        const FORM_PASSWORD            = '74HGD7H9l3m3m3I(*$@;...';
        const EMAIL_FROM_NAME          = 'WHMCS System';
        const PAGING_SIZE              = 25;
        const CUSTOM_CLIENT_FIELD_NAME = 'Mail Paper Invoice';
        const CUSTOM_CLIENT_FIELD_DESC = 'When selected an invoice will be mailed via Docsaway.com';
        const PDF_FONT                 = 'freesans';

        /** [ STATIC PROPERTIES ] */
        public static $alert;
        public static $lang;
        public static $whmcs;
        public static $admin = true;

		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
        
	    /** [ METHOD: PATHS ] */
        public static function basePath(){return(self::basePathFunc());}
        public static function baseURL(){return(self::baseURLFunc());}
        public static function pluginURL(){return(self::pluginURLFunc());}
        public static function pluginPath(){return(self::pluginPathFunc());}
        public static function whmcsVerificationURL(){return(self::whmcsVerificationURLFunc());}
        
        /** [ METHOD: OTHERS ] */
        public static function admin(){return(self::adminFunc());}
        public static function extensionsLoaded($log){return(self::extensionsLoadedFunc($log));}
        public static function cryption($data,$action){return(self::cryptionFunc($data,$action));}
        public static function dateFormat($format,$dateTime){return(self::dateFormatFunc($format,$dateTime));}
        public static function name($str){return(self::nameFunc($str));}
        public static function language($arr){self::$lang=$arr['_lang'];}
        public static function whmcs($arr){unset($arr['_lang']); self::$whmcs=$arr;}
        public static function code($length){return(self::codeFunc($length));}
        public static function clientID($id,$type,$action){return(self::clientIDFunc($id,$type,$action));}
        public static function email($to,$from,$fName,$subject,$message){return(self::emailFunc($to,$from,$fName,$subject,$message));}
        public static function paging($page,$total){return(self::pagingFunc($page,$total));}
        
        /** [ METHOD: MESSAGING ] */
        public static function alert($message,$type,$token){self::alertFunc($message,$type,$token);}
        public static function logActivity($desc,$token){self::logActivityFunc($desc,$token);}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
                 
        /** [ METHOD: IMPORT CLASS ] */	
        private static function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new whmcs());
                }
            }
            
        /** [ METHOD: EXTENSIONS LOADED ] */
        private static function extensionsLoadedFunc($log)
            {
            /** [ DEFAULT: XHTML ] */
            $xhtml='';
            
            /** [ REQUIRED: EXTENSIONS ] */
            $arr['mbstring'] =array('debugger'=>'PHP Extension: mbstring not found','lang'=>globals::$lang['extension']['m2']);
            $arr['openssl']  =array('debugger'=>'PHP Extension: openssl not found','lang'=>globals::$lang['extension']['m3']);
            $arr['curl']     =array('debugger'=>'PHP Extension: curl not found','lang'=>globals::$lang['extension']['m4']);
            
            /** [ CHECK: EXTENSIONS LOADED ] */
            foreach($arr as $k => $v)
                {
                /** [ ERROR: EXTENSION NOT LOADED ] */
                if(!extension_loaded($k))
                    {
                    /** [ METHOD: DEBUGGER ] */
                    if($log===true){debugger::err($v['debugger'],__FILE__,__CLASS__,__METHOD__,__LINE__);}
                    
                    /** [ METHOD: LOG ACTIVITY ] */
                    if($log===true){globals::logActivity($v['lang'],false);}
                    
                    /** [ BUILD: XHTML ] */
                    $xhtml.=$v['lang'].'<br/>';
                    }                
                }
                
            /** [ RETURN: BOOLEAN ] */
            if(empty($xhtml)){unset($xhtml); return(false);}
            
            /** [ RETURN: XHTML ] */
            return($xhtml);
            }  
            
        /** [ METHOD: BASE PATH ] */
        private static function basePathFunc()
            {
            /** [ METHOD: WINDOW OS ] */
            if(self::windowOS()===false){$leadingSlash='/';}else{$leadingSlash='';}
            
            /** [ METHOD: STANDARDISE SLASHES ] */
            $path['DIRNAME_FILE']=self::standardiseSlashes(dirname(__FILE__));

            /** [ FORMAT: SHOW BASE DIRECTORY ONLY  ] */
            $path=str_replace('modules/addons/'.self::PLUGIN_ID.'/classes','',$path['DIRNAME_FILE']);

            /** [ RETURN: PATH ] */
            return($leadingSlash.$path);
            }    

        /** [ METHOD: BASE URL ] */
        private static function baseURLFunc()
            {
            /** [ METHOD: STANDARDISE SLASHES ] */
            $path['DOCUMENT_ROOT']=self::standardiseSlashes($_SERVER['DOCUMENT_ROOT']);
            $path['DIRNAME_FILE']=self::standardiseSlashes(dirname(__FILE__));
            $path['SERVER_NAME']=self::standardiseSlashes($_SERVER['SERVER_NAME']);
         
            /** [ FIND: PATH TO FILE ] */
            $arr=explode($path['DOCUMENT_ROOT'],$path['DIRNAME_FILE']);
            
            /** [ CONSTRUCT: URL PATH ] */
            $path=$path['SERVER_NAME'].$arr[1];
            
            /** [ FORMAT: SHOW BASE DIRECTORY ONLY  ] */
            $path=str_replace('modules/addons/'.self::PLUGIN_ID.'/classes','',$path);
            
            /** [ METHOD: STANDARDISE SLASHES ] */
            $path=self::standardiseSlashes($path);
            
            /** [ GENERATE: COMPLETE PATH ] */
            $path=self::httpType().'://'.$path.'/';
            
            /** [ RETURN: PATH ] */
            unset($arr); return($path);
            }  
   
        /** [ METHOD: PLUGIN PATH ] */
        private static function pluginPathFunc()
            {
            /** [ METHOD: WINDOW OS ] */
            if(self::windowOS()===false){$leadingSlash='/';}else{$leadingSlash='';}
            
            /** [ METHOD: STANDARDISE SLASHES ] */
            $path['DIRNAME_FILE']=self::standardiseSlashes(dirname(__FILE__));
            
            /** [ FORMAT: SHOW BASE DIRECTORY ONLY  ] */
            $path=str_replace('addons/'.self::PLUGIN_ID.'/classes','addons/'.self::PLUGIN_ID,$path['DIRNAME_FILE']);

            /** [ RETURN: PATH ] */
            return($leadingSlash.$path);
            }
            
        /** [ METHOD: PLUGIN URL ] */
        private static function pluginURLFunc()
            {
            /** [ METHOD: STANDARDISE SLASHES ] */
            $path['DOCUMENT_ROOT']=self::standardiseSlashes($_SERVER['DOCUMENT_ROOT']);
            $path['DIRNAME_FILE']=self::standardiseSlashes(dirname(__FILE__));
            $path['SERVER_NAME']=self::standardiseSlashes($_SERVER['SERVER_NAME']);
            
            /** [ FIND: PATH TO FILE ] */
            $arr=explode($path['DOCUMENT_ROOT'],$path['DIRNAME_FILE']);
            
            /** [ CONSTRUCT: URL PATH ] */
            $path=$path['SERVER_NAME'].$arr[1];
            
            /** [ FORMAT: SHOW BASE DIRECTORY ONLY  ] */
            $path=str_replace('addons/'.self::PLUGIN_ID.'/classes','addons/'.self::PLUGIN_ID,$path);
            
            /** [ METHOD: STANDARDISE SLASHES ] */
            $path=self::standardiseSlashes($path);
            
            /** [ GENERATE: COMPLETE PATH ] */
            $path=self::httpType().'://'.$path.'/';            
            
            /** [ RETURN: PATH ] */
            unset($arr); return($path);
            }
            
        /** [ METHOD: WHMCS VERIFICATION URL ] */
        private static function whmcsVerificationURLFunc()
            {
            /** [ CREATE: URL ] */
            $url=self::baseURL().'index.php?m='.self::PLUGIN_ID;
            
            /** [ RETURN: URL ] */
            return($url);
            }              
            
	/** [ METHOD: ADMIN ] */
	private static function adminFunc()
            {
            /** [ IGNORE: ADMIN SELECTION ] */
            if(self::$admin===false){return('');}
            
            /** [ METHOD: WHMCS ] */
            $obj=self::importClass(1);
            $file=$obj->getAdmin();
            unset($obj);
            
            /** [ ERROR: ADMIN NOT LOADED ] */
            if($file===false){unset($file); return(false);}
            
            /** [ RETURN: USERNAME ] */
            return($file['username']);	
            }

        /** [ METHOD: CRYPTION ] */
        private static function cryptionFunc($data,$action)
            {
            /** [ ERROR: DATA NOT SET ] */
            if(empty($data)){return(false);}

            $encrypt_method = "AES-256-CBC";
            $secret_key = md5(self::CRYPT_KEY);
            $secret_iv = md5(md5(self::CRYPT_KEY));

            $key = hash('sha256', $secret_key);
            $iv = substr(hash('sha256', $secret_iv), 0, 16);

            /** [ ACTION: SELECTION ] */
            switch($action)
                {
                /** [ ENCODE: DATA ] */
                case 'encode':

                    /** [ DATA: SERIALIZE ] */
                    $data=serialize($data);

                    /** [ DATA: ENCRYPT ] */
                    $data=base64_encode(openssl_encrypt($data,$encrypt_method,$key,0,$iv)); break;

                /** [ DECODE: DATA ] */
                case 'decode':

                    /** [ DATA: DECRYPT ] */
                    $data=openssl_decrypt(base64_decode($data),$encrypt_method,$key,0,$iv);

                    /** [ DATA: UNSERIALIZE ] */
                    $data=@unserialize($data); break;
                }

            /** [ RETURN: DATA ] */
            return($data);
        }

        /** [ METHOD: DATE FORMAT ] */
	private static function dateFormatFunc($format,$dateTime)
            {
            /** [ SPLIT: DATE/TIME ] */
            $arr=explode(" ",$dateTime);	
			
            /** [ STORE: DATE ] */
            $d=explode("-",$arr[0]); 
			
            /** [ STORE: TIME ] */
            if(!empty($arr[1])){$t=mb_split(":",$arr[1]);}
			
            /** [ STORE: DEAFULT TIME SETTINGS ] */
            else{$t=array(0=>0,1=>0,2=>0);} 
			
            /** [ ERROR: RETURN DATE/TIME  ] */
            if(@checkdate($d[1],$d[2],$d[0])==false){unset($arr); return(false);}
			
            /** [ RETURN: DATE ] */
            unset($arr); return(date($format,mktime($t[0],$t[1],$t[2],$d[1],$d[2],$d[0])));
            }
            
	/** [ METHOD: NAME ] */
	private static function nameFunc($str)
            {
            /** [ ERROR: STRING EMPTY ] */
            if(empty($str)){return($str);}
            
            /** [ SPLIT: NAME ] */
            $arr=mb_split(' ',$str);
            
            /** [ STORE: FIRST NAME ] */
            $name['first']=trim($arr[0]); unset($arr[0]);
            
            /** [ STORE: LAST NAME ] */
            $name['last']=trim(implode(' ',$arr));

            /** [ RETURN: ARRAY ] */
            unset($arr); return($name);
            } 
            
        /** [ METHOD: CODE ] */    
        private static function codeFunc($length)
            {
            /** [ GENERATE ARRAY - NUMS ] */
            $nums=range(0,9);	
		
            /** [ RESET CODE PROPERTY ] */	
            $code='';	
					
            /** [ GENERATE CODE ] */	
            for($i=1; $i<=$length; $i++){$code.=$nums[mt_rand(0,9)];}
            
            /** [ RETURN: CODE ] */
            unset($nums); return($code);
            }
            
        /** [ METHOD: CLIENT ID ] */    
        private static function clientIDFunc($id,$type,$action)
            {
            /** [ ERROR: PROPERTIES NOT SET ] */
            if(empty($id)||!isset($type)){return(false);}
            
            /** [ ACTION: SELECTION ] */
            switch(strtoupper($action))
                {
                /** [ ENCODE1: TYPE: 0|1 ] */
                case 'ENCODE:1': $result=(($type==0) ? 'CL'.$id : 'CO'.$id); break;
                    
                /** [ ENCODE2: TYPE: ID ] */
                case 'ENCODE:2': $result=(($type==0) ? 'CL'.$id : 'CO'.$type); break;            
            
                /** [ DECODE: ID ] */
                case 'DECODE': 
                    
                    /** [ STRIP: TYPE CHARACTERS OUT ] */
                    $arr['type']=substr($id,0,2);
                    
                    /** [ REMOVE: TYPE CHARACTERS FROM ID ] */
                    $arr['id']=str_replace($arr['type'],'',$id);
                    
                    /** [ CONVERT: TYPE CHARACTERS ] */
                    $arr['type']=($arr['type']=='CL') ? 0 : 1;
                    
                    /** [ STORE: ID | TYPE ] */
                    $result=array('id'=>$arr['id'],'type'=>$arr['type']); unset($arr); break;
                }
            
            /** [ RETURN: RESULT ] */
            return($result);
            }   
        
        /** [ METHOD: EMAIL ] */
        private static function emailFunc($to,$from,$fName,$subject,$message)
            {
            /** [ GENERATE: EMAIL HEADER ] */
            $header = "From: \"".$fName."\" <".$from."> \n".
                      "MIME-Version: 1.0 \n".
                      "X-Priority: NORMAL \n".
                      "X-MSMail-Priority: Normal \n".									 
                      "Content-Type: text/plain; charset=utf-8 \n".
                      "Content-Transfer-Encoding: base64";
                                                    
            /** [ SEND: EMAIL ] */
            if(mb_send_mail($to,$subject,$message,$header,'-f'.$from)===false)
                {
                /** [ METHOD: DEBUGGER ] */
                debugger::err('Failed to send email ('.$message.')',__FILE__,__CLASS__,__METHOD__,__LINE__);
                
                /** [ RETURN: BOOLEAN ] */
                return(false); 
                }
                          
            /** [ RETURN: BOOLEAN ] */
            return(true);            
            }
            
        /** [ METHOD: PAGING ] */    
        private static function pagingFunc($page,$total)
            {
            /** [ CALCULATE: PAGE ] */
            $arr['page']=$page+1;
          
            /** [ CALCULATE: TOTAL PAGES ] */
            $arr['totalPages']=ceil($total/globals::PAGING_SIZE);

            /** [ PAGING: NOT REQUIRED: EMPTY RECORDSET ] */
            if($arr['totalPages']==1){return(array('p'=>0,'n'=>0,'total'=>1,'page'=>1));}
            
            /** [ PAGING: NOT REQUIRED: PAGE EQUALS TOTAL PAGES ] */
            if($arr['page']==1&&$page==$arr['totalPages']){return(array('p'=>0,'n'=>0,'total'=>1,'page'=>1));}
            
            /** [ PAGING: BEGINING ] */
            if($arr['page']==1&&$page<$arr['totalPages']){return(array('p'=>0,'n'=>($page+1),'total'=>$arr['totalPages'],'page'=>1));}
            
            /** [ PAGING: NORMAL ] */
            if($arr['page']<$arr['totalPages']){return(array('p'=>($page-1),'n'=>($page+1),'total'=>$arr['totalPages'],'page'=>$arr['page']));}

            /** [ PAGING: END ] */
            return(array('p'=>($page-1),'n'=>$page,'total'=>$arr['totalPages'],'page'=>$arr['page']));
            }
            
        /** [ METHOD: ALERT ] */
        private static function alertFunc($message,$type,$token)
            {
            /** [ IGNORE: ALERT NOT EMPTY ] */
            if(!empty(self::$alert)){return(false);}
            
            /** [ TOKEN: REPLACEMENT ] */
            if($token!==false){foreach($token as $k => $v){$message=str_replace('{TOKEN:'.strtoupper($k).'}',$v,$message);}}            
            
            /** [ SET: CLASS ] */
            switch($type)
                {
                /** [ ADMIN: STYLES ] */
                case 1: $type='successbox'; break;
                case 2: $type='errorbox'; break;
                
                /** [ CLIENT: STYLES ] */
                case 3: $type='alert alert-success'; break;
                case 4: $type='alert alert-danger'; break;
                }
            
            /** [ STORE: ALERT STRING ] */
            self::$alert=array('message'=>$message,'type'=>$type);
            
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: LOG ACTIVITY ] */
        private static function logActivityFunc($desc,$token)
            {
            /** [ TOKEN: REPLACEMENT ] */
            if($token!==false){foreach($token as $k => $v){$desc=str_replace('{TOKEN:'.strtoupper($k).'}',$v,$desc);}}            
            
            /** [ METHOD: WHMCS ] */
            $obj=self::importClass(1);
            $boolean=$obj->logActivity($desc);
            unset($obj);
            
            /** [ ERROR: ACTIVITY NOT LOGGED ] */
            if($boolean===false){unset($boolean); return(false);}
            
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
            
        /** [ METHOD: HYPERTEXT TRANSFER PROTOCOL TYPE ] */    
        private static function httpType()
            {
            /** [ HTTP REFERER: SECURE DETECTED ] */
            if(stristr($_SERVER['HTTP_REFERER'],'https')!==false){return('https');}
            
            /** [ HTTP FORWARDED PROTOCOL: SECURE DETECTED ] */
            if(stristr($_SERVER['HTTP_X_FORWARDED_PROTO'],'https')!==false){return('https');}
            
            /** [ HTTPS: SECURE DETECTED ] */
            if($_SERVER['HTTPS']=='on'){return('https');}
            
            /** [ RETURN: STANDARD ] */
            return('http');
            } 
            
        /** [ METHOD: WINDOW OS ] */    
        private static function windowOS()
            {
            /** [ WINDOWS: DETECTED ] */
            if(stristr(dirname(__FILE__),'\\')!==false){return(true);}
            
            /** [ OTHER OS: DETECTED ] */
            return(false);
            }    
            
        /** [ METHOD: STANDARDISE SLASHES ] */    
        private static function standardiseSlashes($str)
            {
            /** [ CONVERT: WINDOWS SLASHES ] */
            $str=str_replace('\\','/',$str);
            
            /** [ REPLACE: MULTIPLE SLASHES WITH ONE ] */
            $str=preg_replace('/\/{2,}/','/',$str);
            
            /** [ REMOVE: STARTING SLASH ] */
            if($str[0]=='/'){$str=substr($str,1);}            
            
            /** [ REMOVE: TRAILING SLASH ] */
            if(substr($str,-1)=='/'){$str=substr($str,0,-1);}
              
            /** [ RETURN: STRING ] */
            return($str);
            }               
        }
?>