<?php
/**	
 *
 *	LICENSE CLASS
 *	Author: WHMCS | Paul Hamlington
 *	Purpose: Check software license. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;
	

    /** [ LICENSE CLASS ] */
    final class license
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $cfg,$err;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
        
	    /** [ METHOD: SET ] */
	    public function setLicense($key){return($this->setLicenseFunc($key));}
        public function setURL($url){return($this->setUrlFunc($url));}	
        public function setSecretKey($key){return($this->setSecretKeyFunc($key));}	
        public function setKeySettings($checkDays,$failDays){$this->cfg['localkeydays']=$checkDays; $this->cfg['allowcheckfaildays']=$failDays;}
        
        /** [ METHOD: EXECUTE ] */
        public function execute(){return($this->executefunc());}
        
	    /** [ METHOD: DELETE ] */
	    public function delLocalKey(){return($this->deleteLocalKey());}
        
	    /** [ METHOD: GET ] */
        public function getError(){return($this->err);}
	    public function getResults(){return($this->getResultsFunc());}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ CUSTOMISED: SETTINGS ] */
            $this->cfg['licensekey']='';
            $this->cfg['localkey']='';
            $this->cfg['whmcsurl']='';
            $this->cfg['licensing_secret_key']='';
            $this->cfg['localkeydays']=0;
            $this->cfg['allowcheckfaildays']=0; 
            
            /** [ DEFAULT: SETTINGS ] */
            $this->cfg['check_token']=time();
            $this->cfg['checkdate']=date("Ymd");
            $this->cfg['domain']=$_SERVER['SERVER_NAME'];
            $this->cfg['usersip']=isset($_SERVER['SERVER_ADDR'])?$_SERVER['SERVER_ADDR']:$_SERVER['LOCAL_ADDR'];
            $this->cfg['dirpath']=dirname(__FILE__);
            $this->cfg['verifyfilepath']='modules/servers/licensing/verify.php';
            $this->cfg['localkeyvalid']=false;
            $this->cfg['originalcheckdate']=false;
            $this->cfg['regexp']='/<(.*?)>([^<]+)<\/\\1>/i';
            $this->cfg['results']=array();
            
            /** [ DEFAULT: SETTING ] */
            $this->err=0;
            }
        
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new whmcs());
                }
            }
            
        /** [ METHOD: ERROR ] */
        private function error($err)
            {
            /** [ ERROR: SELECTION ] */
            switch($err)
                {
                case 1:  $this->err=array('code'=>'001','description'=>'Remote check failed'); break;
                case 2:  $this->err=array('code'=>'002','description'=>'Invalid license server response'); break;
                case 3:  $this->err=array('code'=>'003','description'=>'MD5 checksum verification failed'); break;
                case 4:  $this->err=array('code'=>'004','description'=>'License key not set'); break;
                case 5:  $this->err=array('code'=>'005','description'=>'WHMCS URL not set'); break;
                case 6:  $this->err=array('code'=>'006','description'=>'Licensing secret key not set'); break;
                case 7:  $this->err=array('code'=>'007','description'=>'License key not active'); break;
                case 8:  $this->err=array('code'=>'008','description'=>'License key is invalid'); break;
                case 9:  $this->err=array('code'=>'009','description'=>'License key is expired'); break;
                case 10: $this->err=array('code'=>'010','description'=>'License key is suspended'); break;
                }
                
            /** [ RETURN: BOOLEAN ] */    
            return(true);
            }
            
        /** [ METHOD: SET LICENSE ] */    
        private function setLicenseFunc($key)
            {
            /** [ ERROR: LICENSE KEY NOT SET ] */
            if(empty($key)){$this->error(4); return(false);}
            
            /** [ STORE: LICENSE KEY ] */
            $this->cfg['licensekey']=$key;
            
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
            
        /** [ METHOD: SET URL ] */    
        private function setUrlFunc($url)
            {
            /** [ ERROR: WHMCS URL NOT SET ] */
            if(empty($url)){$this->error(5); return(false);}
            
            /** [ STORE: WHMCS URL ] */
            $this->cfg['whmcsurl']=$url;
            
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
            
        /** [ METHOD: SET SECRET KEY ] */    
        private function setSecretKeyFunc($key)
            {
            /** [ ERROR: SECRET KEY NOT SET ] */
            if(empty($key)){$this->error(6); return(false);}
            
            /** [ STORE: LICENSE SECRET KEY ] */
            $this->cfg['licensing_secret_key']=$key;
            
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }            
            
        /** [ METHOD: EXECUTE ] */    
        private function executefunc()
            {
            /** [ BUILD: TOKEN ] */
            $this->cfg['check_token'].=md5(mt_rand(1000000000,9999999999).$this->cfg['licensekey']);

            /** [ METHOD: LOAD LOCAL KEY ] */
            $this->loadLocalKey();
            
            /** [ METHOD: LOCAL KEY ] */
            if($this->localKey()==true){return(true);}    
               
            /** [ METHOD: CURL ] */
            if($this->curl()==false){return(false);}    
            
            /** [ ERROR: INVALID SERVER RESPONSE ] */
            if(!is_array($this->cfg['results'])){$this->error(2); return(false);}
            
            /** [ ERROR: MD5 CHECKSUM FAILURE  ] */
            if($this->cfg['results']['md5hash']){if($this->cfg['results']['md5hash']!=md5($this->cfg['licensing_secret_key'].$this->cfg['check_token'])){$this->error(2); return(false);}}
                
            /** [ STORE: REMOTE CHECK ] */
            $this->cfg['results']['remotecheck']=true;
            
            /** [ STATUS: NOT ACTIVE ] */
            if($this->cfg['results']['status']!=='Active'){$this->statusConversion($this->cfg['results']['status']); return(false);}
                
            /** [ STORE: CHECKDATE ] */
            $this->cfg['results']['checkdate']=$this->cfg['checkdate'];
           
            /** [ ENCODE: LOCAL KEY ] */
            $arr['localkey'] = serialize($this->cfg['results']);
            $arr['localkey'] = base64_encode($arr['localkey']);
            $arr['localkey'] = md5($this->cfg['checkdate'].$this->cfg['licensing_secret_key']).$arr['localkey'];
            $arr['localkey'] = strrev($arr['localkey']);
            $arr['localkey'] = $arr['localkey'].md5($arr['localkey'].$this->cfg['licensing_secret_key']);
            $arr['localkey'] = wordwrap($arr['localkey'],80,"\n",true);
            $this->cfg['results']['localkey'] = $arr['localkey'];
            
            /** [ METHOD: SAVE LOCAL KEY ] */
            $this->saveLocalKey($arr['localkey']);
            
            /** [ RETURN: BOOLEAN ] */
            unset($arr); return(true);
            }
            
        /** [ METHOD: LOCAL KEY ] */    
        private function localKey()
            {
            /** [ ERROR: LOCAL KEY EMPTY ] */
            if(empty($this->cfg['localkey'])){return(false);}
            
            /** [ REMOVE: LINE BREAKS ] */
            $this->cfg['localkey'] = str_replace("\n",'',$this->cfg['localkey']);
            
            /** [ EXTRACT: LICENSE DATA | MD5 HASH ] */
            $arr['localdata'] = substr($this->cfg['localkey'],0,strlen($this->cfg['localkey'])-32);
            $arr['md5hash'] = substr($this->cfg['localkey'],strlen($this->cfg['localkey'])-32);
            
            /** [ ERROR: DATA MISMATCH ] */
            if($arr['md5hash'] !== md5($arr['localdata'].$this->cfg['licensing_secret_key'])){unset($arr); return(false);}
            
            /** [ REVERSE: STRING ] */
            $arr['localdata'] = strrev($arr['localdata']);
            
            /** [ EXTRACT: MD5 HASH | LICENSE DATA ] */
            $arr['md5hash'] = substr($arr['localdata'],0,32);
            $arr['localdata'] = substr($arr['localdata'],32);
            
            /** [ LOCAL DATA: ENCODE | UNSERIALIZE  ] */
            $arr['localdata'] = base64_decode($arr['localdata']);
            $arr['localkeyresults'] = unserialize($arr['localdata']);
            $this->cfg['originalcheckdate'] = $arr['localkeyresults']['checkdate'];
                    
            /** [ ERROR: DATA MISMATCH ] */
            if($arr['md5hash'] !== md5($this->cfg['originalcheckdate'].$this->cfg['licensing_secret_key'])){$this->cfg['results']=$arr['localkeyresults']; unset($arr); return(false);}
            
            /** [ STORE: EXPIRY DATE ] */
            $arr['localexpiry'] = date("Ymd",mktime(0,0,0,date("m"),date("d")-$this->cfg['localkeydays'],date("Y")));
                        
            /** [ DATE: STILL ACTIVE ] */      
            if($this->cfg['originalcheckdate'] <= $arr['localexpiry']){$this->cfg['results']=$arr['localkeyresults']; unset($arr); return(false);}
            
            /** [ STRINGS: TO ARRAYS ] */
            $arr['validdomains'] = explode(',',$arr['localkeyresults']['validdomain']);
            $arr['validips'] = explode(',',$arr['localkeyresults']['validip']);
            $arr['validdirs'] = explode(',',$arr['localkeyresults']['validdirectory']);

            /** [ ERROR: RETURN BOOLEAN ] */                
            if(!in_array($_SERVER['SERVER_NAME'],$arr['validdomains'])){unset($arr); return(false);}
            if(!in_array($this->cfg['usersip'],$arr['validips'])){unset($arr); return(false);}
            if(!in_array($this->cfg['dirpath'],$arr['validdirs'])){unset($arr); return(false);}   
                         
            /** [ STORE: VALID KEY SETTINGS ] */
            $this->cfg['results'] = $arr['localkeyresults'];            

            /** [ RETURN: BOOLEAN ] */
            unset($arr); return(true);
            }
            
        /** [ METHOD: CURL ] */    
        private function curl()
            {
            /** [ BUILD: POST ARRAY ] */
            $arr['post'] = array('licensekey'=>$this->cfg['licensekey'],'domain'=>$this->cfg['domain'],'ip'=>$this->cfg['usersip'],'dir'=>$this->cfg['dirpath'],'check_token'=>$this->cfg['check_token']);
            
            /** [ BUILD: POST STRING ] */
            foreach($arr['post'] as $k=>$v){$arr['query_string'].=$k.'='.urlencode($v).'&';}
                
            /** [ OBJECT: FSOCKOPEN ] */
            if(!function_exists('curl_exec'))
                {                
                /** [ CALCULATE: LOCAL EXPIRY ] */
                $arr['localexpiry'] = date("Ymd",mktime(0,0,0,date("m"),date("d")-($this->cfg['localkeydays']+$this->cfg['allowcheckfaildays']),date("Y")));
                    
                /** [ LOCAL KEY: NOT EXPIRIED ] */
                if($this->cfg['originalcheckdate'] > $arr['localexpiry']){unset($arr); return(true);}
                
                /** [ ERROR: REMOTE CHECK FAILED ] */
                $this->error(1);
                
                /** [ RETURN: BOOLEAN ] */
                unset($arr); return(false);
                }
                
            /** [ OBJECT: CURL ] */    
            $arr['ch'] = curl_init();
            curl_setopt($arr['ch'],CURLOPT_URL,$this->cfg['whmcsurl'].$this->cfg['verifyfilepath']);         
            curl_setopt($arr['ch'],CURLOPT_POST,true);
            curl_setopt($arr['ch'],CURLOPT_POSTFIELDS,$arr['query_string']);
            curl_setopt($arr['ch'],CURLOPT_TIMEOUT,30);
            curl_setopt($arr['ch'],CURLOPT_RETURNTRANSFER,true);
            curl_setopt($ch,CURLOPT_SSLVERSION,CURL_SSLVERSION_TLSv1);
            curl_setopt($arr['ch'],CURLOPT_SSL_VERIFYPEER,false);
            curl_setopt($arr['ch'],CURLOPT_SSL_VERIFYHOST,false);             
            $arr['data'] = curl_exec($arr['ch']);
            curl_close($arr['ch']);   

            /** [ FORMAT: DATA ] */
            preg_match_all($this->cfg['regexp'],$arr['data'],$matches);
            foreach($matches[1] as $k=>$v){$arr['results'][$v] = $matches[2][$k];}                   
               
            /** [ STORE: RESULTS ] */
            $this->cfg['results']=$arr['results'];
                
            /** [ RETURN: BOOLEAN ] */
            unset($arr); return(true);
            }
            
        /** [ METHOD: STATUS CONVERSION ] */     
        private function statusConversion($status)
            {
            /** [ STATUS: SELECTION ] */
            switch(strtoupper($status))
                {
                /** [ KEY: INVALID ] */
                case 'INVALID': $this->error(8); break;
                
                /** [ KEY: EXPIRED ] */
                case 'EXPIRED': $this->error(9); break; 
                
                /** [ KEY: SUSPENDED ] */
                case 'SUSPENDED': $this->error(10); break;
                
                /** [ KEY: NOT ACTIVE ] */
                default: $this->error(7); break;
                }
                
            /** [ RETURN: BOOLEAN ] */    
            return(true);
            }
 
        /** [ METHOD: SAVE LOCAL KEY ] */    
        private function saveLocalKey($data)
            {
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(1);           
            $obj->saveSettings('license',$data);

            /** [ RETURN: BOOLEAN ] */
            unset($obj); return(true);
            }
            
        /** [ METHOD: LOAD LOCAL KEY ] */
	    private function loadLocalKey()
            {
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(1);
            $this->cfg['localkey']=$obj->loadSettings('license');

            /** [ RETURN: BOOLEAN ] */
            unset($obj); return(true);			                           
            }
            
        /** [ METHOD: DELETE LOCAL KEY ] */
	    private function deleteLocalKey()
            {
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(1);           
            $obj->deleteSettings('license');

            /** [ RETURN: BOOLEAN ] */
            unset($obj); return(true);	                           
            }            
                    
        /** [ METHOD: GET RESULTS ] */
        private function getResultsFunc()
            {
            /** [ ERROR: PROPERTY EMPTY ] */
            if(empty($this->cfg['results'])){return(false);}
            
            /** [ RETURN: RESULTS ] */
            return($this->cfg['results']);
            }
	    }
?>