<?php 
/** --> ERROR: ACCESSED DENIED */
    if(!defined("WHMCS"))die("This file cannot be accessed directly");

/** --> CORE: INI SETTINGS */
    ini_set('default_charset', 'UTF-8');              /** [ SET DEFAULT CHARSET TO UTF-8 ] */
    ini_set('mbstring.detect_order', 'auto');         /** [ SET DEFAULT CHARACTER ENCODING DETECTION ORDER TO AUTO ] */
    ini_set('mbstring.encoding_translation', 'on');   /** [ HTTP INPUT ENCODING TRANSLATION IS ENABLED ] */
    ini_set('mbstring.language', 'Neutral');          /** [ SET DEFAULT LANGUAGE TO NEUTRAL(UTF-8) ] */
    ini_set('mbstring.substitute_character', 'none'); /** [ DO NOT PRINT INVALID CHARACTERS ] */
    
/** --> LOAD: CLASSES */
    require_once('classes/debugger_class.php');
    require_once('classes/globals_class.php');
    require_once('classes/templates_class.php'); 
    require_once('classes/whmcs_class.php'); 
    require_once('classes/docsaway_class.php');
    require_once('classes/pdf_verification_class.php');    
    require_once('classes/country_class.php');
    require_once('classes/license_class.php');
    require_once('wrappers/hook/h_home_class.php');  
    require_once('wrappers/hook/h_invoice_created_class.php');
    require_once('wrappers/hook/h_accept_order_class.php');  
    require_once('wrappers/hook/h_daily_cronjob_class.php');
    require_once('wrappers/hook/h_client_summary_class.php');    


/** --------------------------> INTERFACE FUNCTIONS <-------------------------- */


/** [ FUNCTIONS: HOOKS ] */ 
    add_hook('AdminHomepage',1,'modulized_docsaway_hook_home'); 
    add_hook('InvoiceCreated',1,'modulized_docsaway_hook_invoice_created');   
    add_hook('AcceptOrder',1,'modulized_docsaway_hook_accept_order');
    add_hook('DailyCronJob',0,'modulized_docsaway_hook_daily_cronjob');
    add_hook('AdminAreaClientSummaryPage',1,'modulized_docsaway_hook_client_summary');

/** [ FUNCTION: HOOK HOME ] */
    function modulized_docsaway_hook_home()
        {
        /** [ FUNCTION: DOCSAWAY LANGUAGE ] */
        modulized_docsaway_language();
        
        /** [ OBJECT: HOOK INVOICE CREATED ] */
        $obj=new modulized_docsaway\h_home();
        $obj->execute();
        $xhtml=$obj->getXHTML();
        unset($obj);
        
        /** [ RETURN: XHTML HOMEBAR ] */
        return($xhtml);   
        }
        
/** [ FUNCTION: HOOK CLIENT SUMMARY ] */
    function modulized_docsaway_hook_client_summary($vars)
        {       
        /** [ FUNCTION: DOCSAWAY LANGUAGE ] */
        modulized_docsaway_language();
        
        /** [ OBJECT: HOOK CLIENT SUMMARY ] */
        $obj=new modulized_docsaway\h_client_summary();
        $obj->setClientID($vars['userid']);
        $obj->execute();
        $xhtml=$obj->getXHTML();
        unset($obj); 
        
        /** [ RETURN: XHTML CLIENT SUMMARY ] */        
        return($xhtml);        
        }        
        
/** [ FUNCTION: HOOK INVOICE CREATED ] */
    function modulized_docsaway_hook_invoice_created($vars)
        {
        /** [ FUNCTION: DOCSAWAY LANGUAGE ] */
        modulized_docsaway_language();
        
        /** [ FUNCTION: LICENSE ] */
        if(modulized_docsaway_license()===false){return;}        
        
        /** [ OBJECT: HOOK INVOICE CREATED ] */
        $obj=new modulized_docsaway\h_invoice_created();
        $obj->setInvoiceID($vars['invoiceid']);
        $obj->execute();
        unset($obj);
        }
        
/** [ FUNCTION: HOOK ACCEPT ORDER ] */
    function modulized_docsaway_hook_accept_order($vars)
        {
        /** [ FUNCTION: DOCSAWAY LANGUAGE ] */
        modulized_docsaway_language();

        /** [ FUNCTION: LICENSE ] */
        if(modulized_docsaway_license()===false){return;}        
        
        /** [ OBJECT: HOOK ACCEPT ORDER ] */
        $obj=new modulized_docsaway\h_accept_order();
        $obj->setOrderID($vars['orderid']);
        $obj->execute();
        unset($obj);         
        }
        
/** [ FUNCTION: HOOK DAILY CRONJOB ] */
    function modulized_docsaway_hook_daily_cronjob()
        {       
        /** [ FUNCTION: DOCSAWAY LANGUAGE ] */
        modulized_docsaway_language();
        
        /** [ FUNCTION: LICENSE ] */
        if(modulized_docsaway_license()===false){return;}        
        
        /** [ OBJECT: HOOK ACCEPT ORDER ] */
        $obj=new modulized_docsaway\h_daily_cronjob();
        $obj->execute();
        unset($obj);         
        }        
           
/** [ FUNCTION: LANGUAGE ] */        
     function modulized_docsaway_language()
        {
        /** [ LOAD: TEMPLATE ] */ 
        ob_start();
        require(modulized_docsaway\globals::pluginPath().'/lang/english.php');
        ob_end_clean();
        
        /** [ STORE: GLOBAL LANGUAGE ] */
        modulized_docsaway\globals::language(array('_lang'=>$_ADDONLANG));        
        
        /** [ RETURN: BOOLEAN ] */
        unset($_ADDONLANG); return(true);
        }   
        
/** [ FUNCTION: LICENSE ] */          
    function modulized_docsaway_license()
        {
        /** [ OBJECT: WHMCS ] */
        $obj=new modulized_docsaway\whmcs();
        $file=$obj->loadSettings('config');
        unset($obj);
            
        /** [ OBJECT: LICENSE ] */
        $obj = new modulized_docsaway\license();
        $obj->setLicense(@$file['license']);
        $obj->setSecretKey(modulized_docsaway\globals::LICENSE_KEY);
        $obj->setKeySettings(modulized_docsaway\globals::LICENSE_CHECKDAYS,modulized_docsaway\globals::LICENSE_FAILDAYS);
        $obj->setURL(modulized_docsaway\globals::LICENSE_URL);
        $obj->execute();
        $error=$obj->getError();
        unset($obj);
        
        /** [ ERROR: LOG ACTIVITY ] */
        if($error['code']>0)
            {
            /** [ METHOD: DEBUGGER ] */
            modulized_docsaway\debugger::err('license failure: '.$error['description'].' ( code: '.$error['code'].' )',__FILE__,__CLASS__,__METHOD__,__LINE__);             
            
            /** [ METHOD: LOG ACTIVITY ] */
            modulized_docsaway\globals::logActivity(modulized_docsaway\globals::$lang['log']['license']['m1'],array('description'=>$error['description'],'code'=>$error['code']));

            /** [ RETURN: BOOLEAN ] */
            unset($error,$file); return(false);
            }
        
        /** [ RETURN: BOOLEAN ] */
        unset($error,$file); return(true);
        }
?>