<?php 
    /** --> ERROR: ACCESSED DENIED */
    if(!defined("WHMCS"))die("This file cannot be accessed directly");
        
    /** --> CORE: INI SETTINGS */
    ini_set('default_charset', 'UTF-8');              /** [ SET DEFAULT CHARSET TO UTF-8 ] */
    ini_set('mbstring.detect_order', 'auto');         /** [ SET DEFAULT CHARACTER ENCODING DETECTION ORDER TO AUTO ] */
    ini_set('mbstring.encoding_translation', 'on');   /** [ HTTP INPUT ENCODING TRANSLATION IS ENABLED ] */
    ini_set('mbstring.language', 'Neutral');          /** [ SET DEFAULT LANGUAGE TO NEUTRAL(UTF-8) ] */
    ini_set('mbstring.substitute_character', 'none'); /** [ DO NOT PRINT INVALID CHARACTERS ] */
    
    /** --> LOAD: CLASSES */
    require_once('classes/debugger_class.php');
    require_once('classes/globals_class.php');
    require_once('classes/templates_class.php');
    require_once('classes/validation_class.php');    
    require_once('classes/whmcs_class.php'); 
    require_once('classes/docsaway_class.php');
    require_once('classes/pdf_verification_class.php');
    require_once('classes/pdf_certificate_class.php');
    require_once('classes/pdf_letter_class.php');
    require_once('classes/country_class.php');   
    require_once('classes/license_class.php');
    require_once('wrappers/admin/a__configuration_class.php');
    require_once('wrappers/admin/a__letter_class.php');    
    require_once('wrappers/admin/a__invoices_class.php');
    require_once('wrappers/admin/a__verification_class.php');
    require_once('wrappers/admin/a__report_class.php');
    require_once('wrappers/admin/a__sidebar_class.php'); 
    require_once('wrappers/admin/a_action_class.php'); 
    require_once('wrappers/admin/a_action_configuration_class.php');
    require_once('wrappers/admin/a_action_invoices_class.php');
    require_once('wrappers/admin/a_action_verification_class.php');
    require_once('wrappers/admin/a_action_letter_class.php');
    require_once('wrappers/client/c__verification_class.php');
    require_once('wrappers/client/c_action_class.php');
    require_once('wrappers/client/c_action_verification_class.php');    


    /** --------------------------> INTERFACE FUNCTIONS <-------------------------- */

        
    /** [ FUNCTIONS: UNUSED ] */
    function modulized_docsaway_upgrade(){}

    /** [ FUNCTION: CONFIGURATION ] */
    function modulized_docsaway_config()
        { 
        /** [ MODULE SETTINGS: CONFIGURATION ] */
        $config = array("name"        => modulized_docsaway\globals::PLUGIN_NAME,
                        "description" => 'This module connects to the Docsaway.com PDF postal mailing system. This provides the ability for PDF documents such as your WHMCS invoices to be sent to the Docsaway network, where they can be routed to one of many global locations for printing and posting. This means customer invoices are mailed closer to their addresses which usually results in quicker delivery at cheaper costs. <br/><br/>'.
                                         'For more information <a href="http://www.modulized.com/docsaway-about/" style="font-weight:bold; text-decoration:underline;" target="_blank">click here</a>.',
                        "version"     => '3.1',
                        "author"      => '<a href="mailto:support@modulized.com"><img width="114px" height="114px" alt="Modulized.com" src="'.modulized_docsaway\globals::pluginURL().'images/logo_startup1.png" /></a>',
                        "language"    => 'english');
                           
        /** [ RETURN: CONFIG ] */               
        return($config); 
        }
       
    /** [ FUNCTION: ACTIVATE ] */
    function modulized_docsaway_activate()
        {
        /** [ OBJECT: WHMCS ] */
        $obj=new modulized_docsaway\whmcs();
        $obj->createTables();
        unset($obj);
        }     
        
    /** [ FUNCTION: DEACTIVATE ] */
    function modulized_docsaway_deactivate()
        {
        /** [ OBJECT: LICENSE ] */
        $obj = new modulized_docsaway\license();
        $obj->delLocalKey();
        unset($obj);        
        }         
        
    /** [ FUNCTION: SIDEBAR ] */
    function modulized_docsaway_sidebar($vars)
        {     
        /** [ TURN OFF: ADMIN SELECTION ] */
        modulized_docsaway\globals::$admin=false;
        
        /** [ STORE: GLOBAL LANGUAGE ] */
        modulized_docsaway\globals::language($vars);
        
        /** [ STORE: GLOBAL WHMCS ] */
        modulized_docsaway\globals::whmcs($vars);
        
        /** [ METHOD: EXTENSIONS LOADED ] */
        if(modulized_docsaway\globals::extensionsLoaded(true)!==false){return;}
        
        /** [ OBJECT: ACTION ] */
        $obj=new modulized_docsaway\a_action($_POST);
        $obj->execute();
        $xhtml=$obj->getXHTML();
        unset($obj);        
        
        /** [ OUTPUT: XHTML PAGE ] */
        echo($xhtml);
        
        /** [ OBJECT: SIDEBAR ] */
        $obj=new modulized_docsaway\a__sidebar();
        $obj->execute();
        $xhtml=$obj->getXHTML();
        unset($obj);

        /** [ RETURN: XHTML SIDEBAR ] */
        return($xhtml);
        } 
        
    /** [ FUNCTION: OUTPUT ] */
    function modulized_docsaway_output()
        {    
        /** [ METHOD: EXTENSIONS LOADED ] */
        if(($xhtml=modulized_docsaway\globals::extensionsLoaded(false))!==false){echo($xhtml); return;}
        }  
        
    /** [ FUNCTION: CLIENT AREA ] */
    function modulized_docsaway_clientarea($vars)
        {
        /** [ STORE: LOGIN ID ] */
        $vars['uid']=@$_SESSION['uid'];
        
        /** [ STORE: GLOBAL LANGUAGE ] */
        modulized_docsaway\globals::language($vars);
        
        /** [ STORE: GLOBAL WHMCS ] */
        modulized_docsaway\globals::whmcs($vars);
        
        /** [ OBJECT: ACTION ] */
        $obj=new modulized_docsaway\c_action($_POST);
        $obj->execute();
        $arr=$obj->getStructure();
        unset($obj);

        /** [ RETURN: STRUCTURE ] */
        return($arr);
        }        
?>