<?php
/**	
 *
 *	ADMIN: INVOICES CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the invoices page building code. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ ADMIN: INVOICE CLASS ] */
    final class a__invoices
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
	    /** [ METHOD: SET ] */
        public function setInvoiceID($int){if(validation::numeric($int,20,false,false)){$this->globals['invoiceID']=$int;}}
        public function setFields($arr){$this->setFieldsFunc($arr);}         
        
	    /** [ METHOD: EXECUTE ] */
	    public function execute(){return($this->executeFunc());}
        
	    /** [ METHOD: GET ] */
	    public function getXHTML(){return($this->getXHTMLFunc());}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = 
                array('invoiceID'     => false,
                      'clientID'      => false,
                      'postFields'    => false,
                      'invoice'       => '----------  ----------',
                      'client'        => '----------  ----------',
                      'name'          => '----------  ----------',
                      'companyName'   => '----------  ----------',
                      'emailAddress'  => '----------  ----------',
                      'address1'      => '----------  ----------',
                      'address2'      => '----------  ----------',
                      'city'          => '----------  ----------',
                      'state'         => '----------  ----------',
                      'postcode'      => '----------  ----------',
                      'country'       => '----------  ----------',
                      'invoiceDate'   => '----------  ----------',
                      'dateDue'       => '----------  ----------',
                      'datePaid'      => '----------  ----------',
                      'total'         => '----------  ----------',
                      'paymentMethod' => '----------  ----------',
                      'status'        => '----------  ----------',
                      'ink'           => '',
                      'paper'         => '',
                      'mode'          => '', 
                      'xhtml'         => '');

            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new templates());
                case 2: return(new whmcs());
                }
            }
            
        /** [ METHOD: SET FIELDS ] */    
        private function setFieldsFunc($arr)
            {
            /** [ ERROR: FIELDS NOT SET ] */
            if(empty($arr)){return(false);}
            
            /** [ STORE: POST FIELDS ] */
            $this->globals['mode']  =$arr['mode'];
            $this->globals['ink']   =$arr['ink'];
            $this->globals['paper'] =$arr['paper'];

            /** [ STORE: POST FIELDS ] */
            $this->globals['postFields']=true;

            /** [ RETURN: BOOLEAN ] */
            unset($arr); return(true);
            }             
            
        /** [ METHOD: EXECUTE ] */     
        private function executeFunc()
            {      
            /** [ METHOD: CONFIG FILE ] */
            $this->configFile();
            
            /** [ METHOD: INVOICE ] */
            $this->invoice();            
            
            /** [ METHOD: CLIENT ] */
            $this->client();
            
            /** [ METHOD: BUILD PAGE ] */
            $xhtml=$this->buildPage();
            
            /** [ STORE: XHTML ] */
            $this->globals['xhtml']=$xhtml;
            
            /** [ RETURN: BOOLEAN ] */
            unset($xhtml); return(true);
            }
            
        /** [ METHOD: CONFIG FILE ] */    
        private function configFile()
            {
            /** [ IGNORE: POSTED FIELDS DETECTED ] */
            if($this->globals['postFields']==true){return(true);}
            
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(2);
            $file=$obj->loadSettings('config');
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){unset($file); return(false);}
            
            /** [ STORE: SETTINGS ] */
            $this->globals['mode']  =$file['mode'];
            $this->globals['ink']   =$file['ink'];
            $this->globals['paper'] =$file['paper'];
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }            
                
        /** [ METHOD: INVOICE ] */    
        private function invoice()
            {
            /** [ ERROR: INVOICE ID NOT NUMERIC ] */
            if(!is_numeric($this->globals['invoiceID'])){return(false);}
            
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(2);
            $file=$obj->getInvoice($this->globals['invoiceID']);
            $currency=$obj->getBaseCurrency();
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){unset($file,$currency); $this->globals['invoiceID']=false; return(false);}
            
            /** [ STORE: INVOICE SETTINGS ] */
            $this->globals['invoice']       =$file['invoiceid'];
            $this->globals['clientID']      =$file['userid'];
            $this->globals['invoiceDate']   =globals::dateFormat('jS F Y',$file['date']);
            $this->globals['dateDue']       =globals::dateFormat('jS F Y',$file['duedate']);
            $this->globals['total']         =$currency.' '.$file['total'];
            $this->globals['paymentMethod'] =$file['paymentmethod'];
            $this->globals['status']        =$file['status']; 

            /** [ OPTIONAL: FIELDS ] */
            if($file['datepaid']!=0){$this->globals['datePaid']=globals::dateFormat('jS F Y',$file['datepaid']);}            
            
            /** [ RETURN: BOOLEAN ] */
            unset($file,$currency); return(true);
            }            
            
        /** [ METHOD: CLIENT ] */    
        private function client()
            {
            /** [ ERROR: CLIENT ID NOT NUMERIC ] */
            if(!is_numeric($this->globals['clientID'])){return(false);}
            
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(2);
            $file=$obj->getClient($this->globals['clientID']);
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){unset($file); return(false);}
            
            /** [ STORE: CLIENT SETTINGS ] */
            $this->globals['client']       =$file['userid'];
            $this->globals['name']         =$file['fullname'];
            $this->globals['emailAddress'] =$file['email'];
            $this->globals['address1']     =$file['address1'];
            $this->globals['city']         =$file['city'];
            $this->globals['postcode']     =$file['postcode'];
            $this->globals['country']      =country::conv($file['country']);
            
            /** [ OPTIONAL: FIELDS ] */
            if(!empty($file['companyname'])){$this->globals['companyName']=$file['companyname'];}
            if(!empty($file['address2'])){$this->globals['address2']=$file['address2'];}
            if(!empty($file['fullstate'])){$this->globals['state']=$file['fullstate'];}
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }
            
        /** [ METHOD: MODE MENU ] */    
        private function modeMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>'TEST','lang:value'=>'Test');
            $tokens[]=array('value:key'=>'LIVE','lang:value'=>'Live');
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['mode'] ? 'selected="selected"' : '');}   
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }
            
        /** [ METHOD: INK MENU ] */    
        private function inkMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>'BW','lang:value'=>'Black &amp; White');
            $tokens[]=array('value:key'=>'CL','lang:value'=>'Colour');
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['ink'] ? 'selected="selected"' : '');}             
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }
            
        /** [ METHOD: PAPER MENU ] */    
        private function paperMenu()
            {
            /** [ MENU: OPTIONS ] */
            $tokens[]=array('value:key'=>80,'lang:value'=>80);
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$this->globals['paper'] ? 'selected="selected"' : '');}               
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }            
            
        /** [ METHOD: BUILD PAGE ] */    
        private function buildPage()
            {
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['lang:invoices_t1']       =globals::$lang['invoices']['t1'];
            $tokens['lang:invoices_t2']       =globals::$lang['invoices']['t2'];
            $tokens['lang:invoices_t3']       =globals::$lang['invoices']['t3'];
            $tokens['lang:invoices_t4']       =globals::$lang['invoices']['t4'];
            $tokens['lang:invoices_b0_1']     =globals::$lang['invoices']['b0_1'];
            $tokens['lang:invoices_b1_1']     =globals::$lang['invoices']['b1_1'];
            $tokens['lang:invoices_b1_2']     =globals::$lang['invoices']['b1_2'];
            $tokens['lang:invoices_b1_3']     =globals::$lang['invoices']['b1_3'];
            $tokens['lang:invoices_b1_4']     =globals::$lang['invoices']['b1_4'];
            $tokens['lang:invoices_b1_5']     =globals::$lang['invoices']['b1_5'];
            $tokens['lang:invoices_b1_6']     =globals::$lang['invoices']['b1_6'];
            $tokens['lang:invoices_b1_7']     =globals::$lang['invoices']['b1_7'];
            $tokens['lang:invoices_b1_8']     =globals::$lang['invoices']['b1_8'];
            $tokens['lang:invoices_b1_9']     =globals::$lang['invoices']['b1_9'];
            $tokens['lang:invoices_b1_10']    =globals::$lang['invoices']['b1_10'];
            $tokens['lang:invoices_b2_1']     =globals::$lang['invoices']['b2_1'];
            $tokens['lang:invoices_b2_2']     =globals::$lang['invoices']['b2_2'];
            $tokens['lang:invoices_b2_3']     =globals::$lang['invoices']['b2_3'];
            $tokens['lang:invoices_b2_4']     =globals::$lang['invoices']['b2_4'];
            $tokens['lang:invoices_b2_5']     =globals::$lang['invoices']['b2_5'];
            $tokens['lang:invoices_b2_6']     =globals::$lang['invoices']['b2_6'];
            $tokens['lang:invoices_b2_7']     =globals::$lang['invoices']['b2_7'];
            $tokens['lang:invoices_b3_1']     =globals::$lang['invoices']['b3_1'];
            $tokens['lang:invoices_b3_2']     =globals::$lang['invoices']['b3_2'];
            $tokens['lang:invoices_b3_3']     =globals::$lang['invoices']['b3_3'];
            $tokens['lang:invoices_b3_3_1']   =globals::$lang['invoices']['b3_3_1'];
            $tokens['lang:invoices_b3_4']     =globals::$lang['invoices']['b3_4'];
            $tokens['lang:invoices_b0_btn']   =globals::$lang['invoices']['b0_btn'];
            $tokens['lang:invoices_b3_btn']   =globals::$lang['invoices']['b3_btn'];
            
            /** [ VALUE: SETTINGS ] */
            $tokens['value:action']           =globals::$whmcs['modulelink'];
            $tokens['value:btn1_value']       =globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>3),'encode');            
            $tokens['value:btn2_value']       =globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>3,'invoiceID'=>$this->globals['invoiceID'],'clientID'=>$this->globals['clientID'],'mailPDF'=>true),'encode');
            $tokens['value:invoice_id']       =$this->globals['invoiceID'];
            $tokens['value:invoice']          =($this->globals['invoiceID']===false ? $this->globals['invoice'] : '#'.$this->globals['invoice']);
            $tokens['value:client']           =($this->globals['clientID']===false ? $this->globals['client'] : '#'.$this->globals['client']);
            $tokens['value:name']             =$this->globals['name'];
            $tokens['value:company_name']     =$this->globals['companyName'];
            $tokens['value:email_address']    =$this->globals['emailAddress'];
            $tokens['value:address1']         =$this->globals['address1'];
            $tokens['value:address2']         =$this->globals['address2'];
            $tokens['value:city']             =$this->globals['city'];
            $tokens['value:state']            =$this->globals['state'];
            $tokens['value:postcode']         =$this->globals['postcode'];
            $tokens['value:country']          =$this->globals['country'];
            $tokens['value:invoice_date']     =$this->globals['invoiceDate'];
            $tokens['value:date_due']         =$this->globals['dateDue'];
            $tokens['value:date_paid']        =$this->globals['datePaid'];
            $tokens['value:total']            =$this->globals['total'];
            $tokens['value:payment_method']   =$this->globals['paymentMethod'];
            $tokens['value:status']           =$this->globals['status'];
            $tokens['value:mode_options']     =$this->modeMenu();
            $tokens['value:ink_options']      =$this->inkMenu();
            $tokens['value:paper_options']    =$this->paperMenu();
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('admin_invoices',array(0=>$tokens),false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }            
            
        /** [ METHOD: LOAD TEMPLATE ] */
        private function loadTemplate($filename,$tokens,$path)
            {
            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(1);
            $obj->setPath($path);
            $obj->setFileName($filename);
            $obj->setTokens($tokens);
            $xhtml=$obj->getTemplate();
            
            /** [ RETURN: XHTML ] */
            unset($obj); return($xhtml);
            }
            
        /** [ METHOD: GET XHTML ] */    
        private function getXHTMLFunc()
            {
            /** [ ERROR: XHTML NOT SET ] */
            if(empty($this->globals['xhtml'])){return(false);}
            
            /** [ RETURN: XHTML ] */
            return($this->globals['xhtml']);
            }
	}
?>