<?php
/**	
 *
 *	CLIENT: VERIFICATION CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the verification page building code. 
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;
	

    /** [ CLIENT: VERIFICATION CLASS ] */
    final class c__verification
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
	    /** [ METHOD: SET ] */
        public function setFields($arr){$this->setFieldsFunc($arr);}         
        
	    /** [ METHOD: EXECUTE ] */
	    public function execute(){return($this->executeFunc());}
        
	    /** [ METHOD: GET ] */
	    public function getXHTML(){return($this->getXHTMLFunc());}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = 
                array('clientID'   => false,
                      'postFields' => false, 
                      'xhtml'      => '');

            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new templates());
                case 2: return(new whmcs());
                }
            }
            
        /** [ METHOD: SET FIELDS ] */    
        private function setFieldsFunc($arr)
            {
            /** [ ERROR: FIELDS NOT SET ] */
            if(empty($arr)){return(false);}
            
            /** [ STORE: POST FIELDS ] */
            $this->globals['clientID'] =$arr['clientID'];
            $this->globals['code'] =$arr['code'];

            /** [ STORE: POST FIELDS ] */
            $this->globals['postFields']=true;

            /** [ RETURN: BOOLEAN ] */
            unset($arr); return(true);
            }             
            
        /** [ METHOD: EXECUTE ] */     
        private function executeFunc()
            {                                          
            /** [ METHOD: BUILD PAGE ] */
            $xhtml=$this->buildPage();
            
            /** [ STORE: XHTML ] */
            $this->globals['xhtml']=$xhtml;
            
            /** [ RETURN: BOOLEAN ] */
            unset($xhtml); return(true);
            }

        /** [ METHOD: BUILD PAGE ] */    
        private function buildPage()
            {
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['lang:verification_title'] =globals::$lang['verification']['c_title'];
            $tokens['lang:verification_p1']    =globals::$lang['verification']['c_p1'];
            $tokens['lang:verification_r1']    =globals::$lang['verification']['c_r1'];
            $tokens['lang:verification_r2']    =globals::$lang['verification']['c_r2'];
            $tokens['lang:verification_btn']   =globals::$lang['verification']['c_btn'];
    
            /** [ VALUE: SETTINGS ] */
            $tokens['value:action']         =globals::baseURL().'index.php?m='.globals::PLUGIN_ID;          
            $tokens['value:btn_value']      =globals::cryption(array('pw'=>md5(globals::FORM_PASSWORD),'action'=>1),'encode');
            $tokens['value:code']           =$this->globals['code'];
            $tokens['value:client_options'] =$this->clientMenu($this->globals['clientID']);
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('client_verification',array(0=>$tokens));

            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }            
            
        /** [ METHOD: CLIENT MENU ] */    
        private function clientMenu($clientID)
            {
            /** [ OBJECT: WHMCS ] */
            $obj = $this->importClass(2);
            $file=$obj->getClient(globals::$whmcs['uid']);
            if($file===false){unset($file,$obj); return(false);}
            unset($obj);
           
            /** [ MENU: OPTION: CLIENT ] */
            $tokens[]=array('value:key'=>globals::clientID($file['id'],0,'ENCODE:1'),'lang:value'=>$file['id'].': '.$file['firstname'].' '.$file['lastname'].' - '.$file['email']);
                        
            /** [ OBJECT: WHMCS ] */
            $obj = $this->importClass(2);
            $file=$obj->getContacts(globals::$whmcs['uid']);
            unset($obj);
            
            /** [ MENU: OPTION: CONTACTS ] */
            if($file!==false){foreach($file['contacts']['contact'] as $k => $v){$tokens[]=array('value:key'=>globals::clientID($v['id'],1,'ENCODE:1'),'lang:value'=>$v['id'].': '.$v['firstname'].' '.$v['lastname'].' - '.$v['email']);}} unset($file);
            
            /** [ MENU: PRE-SELECTED ] */
            foreach($tokens as $k => $v){$tokens[$k]['value:selected']=($v['value:key']==$clientID ? 'selected="selected"' : '');}               
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('form_option',$tokens,false);
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }
            
        /** [ METHOD: LOAD TEMPLATE ] */
        private function loadTemplate($filename,$tokens)
            {
            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(1);
            $obj->setPath(false);
            $obj->setFileName($filename);
            $obj->setTokens($tokens);
            $xhtml=$obj->getTemplate();
            
            /** [ RETURN: XHTML ] */
            unset($obj); return($xhtml);
            }
            
        /** [ METHOD: GET XHTML ] */    
        private function getXHTMLFunc()
            {
            /** [ ERROR: XHTML NOT SET ] */
            if(empty($this->globals['xhtml'])){return(false);}
            
            /** [ RETURN: XHTML ] */
            return($this->globals['xhtml']);
            }
	}
?>