<?php
/**	
 *
 *	HOOK: HOME CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the home hook code.
 * 
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ HOOK: HOME CLASS ] */
    final class h_home
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
		
		
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		

	    /** [ METHOD: EXECUTE ] */
	    public function execute(){return($this->executeFunc());}
        
	    /** [ METHOD: GET ] */
	    public function getXHTML(){return($this->getXHTMLFunc());}

        
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = 
                array('accountBalance' => '------',
                      'totalSent'      => '------',
                      'moduleMode'     => '------',
                      'homeHook'       => '', 
                      'xhtml'          => '');                    
          
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new templates());
                case 2: return(new docsaway());
                case 3: return(new whmcs());
                }
            }	
            
        /** [ METHOD: EXECUTE ] */     
        private function executeFunc()
            {            
            /** [ METHOD: DOCSAWAY ACCOUNT ] */
            $this->docsawayAccount();
            
            /** [ METHOD: BUILD PAGE ] */
            if(($xhtml=$this->buildPage())==false){return(false);}
            
            /** [ STORE: XHTML ] */
            $this->globals['xhtml']=$xhtml;
            
            /** [ RETURN: BOOLEAN ] */
            unset($xhtml); return(true);
            }
            
        /** [ METHOD: CONFIG FILE ] */    
        private function configFile()
            {           
            /** [ OBJECT: WHMCS ] */
            $obj=$this->importClass(3);
            $file=$obj->loadSettings('config');
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){unset($file); return(false);}
            
            /** [ STORE: SETTINGS ] */
            $this->globals['moduleMode']=$file['mode']; 
            $this->globals['homeHook']=$file['homeHook']; 
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }            
            
        /** [ METHOD: DOCSAWAY ACCOUNT ] */    
        private function docsawayAccount()
            {
            /** [ OBJECT: DOCSAWAY ] */
            $obj=$this->importClass(2);
            $file=$obj->account();
            unset($obj);
            
            /** [ ERROR: CONNECTION FAILURE ] */
            if($file===false){unset($file); return(false);}
            
            /** [ METHOD: CONFIG FILE ] */
            $this->configFile();
            
            /** [ STORE: SETTINGS ] */
            $this->globals['accountBalance'] = globals::BASE_CURRENCY.' '.$file['balance'];
            $this->globals['totalSent'] = $file['volume'].' '.globals::$lang['home']['c2_1'];

            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }
  
        /** [ METHOD: BUILD PAGE ] */    
        private function buildPage()
            {
            /** [ HOOK: HOME DISABLED ] */
            if($this->globals['homeHook']==2){return(false);}
            
            /** [ LANGUAGE: SETTINGS ] */
            $tokens['lang:home_title']       =globals::PLUGIN_NAME;
            $tokens['lang:home_c1']          =globals::$lang['home']['c1'];
            $tokens['lang:home_c2']          =globals::$lang['home']['c2'];
            $tokens['lang:home_c3']          =globals::$lang['home']['c3'];

            /** [ VALUE: SETTINGS ] */
            $tokens['value:account_balance'] =$this->globals['accountBalance'];
            $tokens['value:total_sent']      =$this->globals['totalSent'];
            $tokens['value:module_mode']     =$this->globals['moduleMode'];
            
            /** [ METHOD: LOAD TEMPLATE ] */
            $xhtml=$this->loadTemplate('admin_home',array(0=>$tokens));
            
            /** [ RETURN: XHTML ] */
            unset($tokens); return($xhtml);
            }            
            
        /** [ METHOD: LOAD TEMPLATE ] */
        private function loadTemplate($filename,$tokens)
            {
            /** [ OBJECT: TEMPLATES ] */
            $obj=$this->importClass(1);
            $obj->setFileName($filename);
            $obj->setTokens($tokens);
            $xhtml=$obj->getTemplate();
            
            /** [ RETURN: XHTML ] */
            unset($obj); return($xhtml);
            }
            
        /** [ METHOD: GET XHTML ] */    
        private function getXHTMLFunc()
            {
            /** [ ERROR: XHTML NOT SET ] */
            if(empty($this->globals['xhtml'])){return(false);}
            
            /** [ RETURN: XHTML ] */
            return($this->globals['xhtml']);
            }
	}
?>