<?php
/**	
 * 
 *	HOOK: INVOICE CREATED CLASS
 *	Author: Paul Hamlington
 *	Purpose: Wrap the invoice created hook code.
 *
 */

    /** [ SET NAMESPACE: MODULIZED DOCSAWAY ] */
    namespace modulized_docsaway;	
	

    /** [ HOOK: INVOICE CREATED CLASS ] */
    final class h_invoice_created
        {
	    /** [ PRIVATE CLASS PROPERTIES ] */
	    private $globals;
			
                
	    /** --------------------------> CLASS INTERFACE METHODS <--------------------------*/
		
	
        /** [ METHOD: SET ] */
        public function setInvoiceID($int){$this->globals['invoiceID']=$int;}
        
	    /** [ METHOD: EXECUTE ] */
	    public function execute(){$this->executeFunc();}
		
		
	    /** --------------------------> CLASS FUNCTIONALITY METHODS <--------------------------*/
		
				
	    /** [ METHOD: CONSTRUCTOR ] */
	    public function __construct()
            {
            /** [ DEFAULT: GLOBALS ] */
            $this->globals = 
                array('invoiceID' => '',
                      'clientID'  => '',
                      'recipient' => array());
            
            /** [ RETURN: BOOLEAN ] */
            return(true);            
            }
                    
        /** [ METHOD: IMPORT CLASS ] */	
        private function importClass($class)
            {
            /** [ CLASS SELECTION ] */
            switch($class)
                {
                /** [ IMPORTED OBJECTS ] */
                case 1: return(new whmcs());
                case 2: return(new docsaway());
                }
            }	
       
        /** [ METHOD: EXECUTE ] */		
	    private function executeFunc()
            {
            /** [ ERROR: INVOICE ID NOT SET ] */
            if(empty($this->globals['invoiceID']))
                {
                /** [ METHOD: DEBUGGER ] */
                debugger::err('invoice id property not set',__FILE__,__CLASS__,__METHOD__,__LINE__);                
                
                /** [ METHOD: LOG ACTIVITY ] */
                globals::logActivity(globals::$lang['log']['invoice']['m1'],false);
                
                /** [ RETURN: BOOLEAN ] */
                return(false);
                }
            
            /** [ METHOD: GET INVOICE ] */
            if($this->getInvoice()==false){return(false);}
            
            /** [ METHOD: GET CLIENT ] */
            if($this->getClient()==false){return(false);}
            
            /** [ METHOD: MAIL ] */
            if($this->mail()==false){return(false);}
            
            /** [ RETURN: BOOLEAN ] */
            return(true);
            }
        
        /** [ METHOD: GET INVOICE ] */
        private function getInvoice()
            {
            /** [ OBJECT: WHMCS ] */
            $obj = $this->importClass(1);
            $file=$obj->getInvoice($this->globals['invoiceID']);
            unset($obj);
            
            /** [ ERROR: FILE EMPTY ] */
            if($file===false){globals::logActivity(globals::$lang['log']['invoice']['m2'],array('id'=>$this->globals['invoiceID'])); unset($file); return(false);}
            
            /** [ STORE: CLIENT ID ] */
            $this->globals['clientID']=$file['userid'];    
                
            /** [ RETURN: BOOLEAN ] */ 
            unset($file); return(true);
            }
            
        /** [ METHOD: GET CLIENT ] */
        private function getClient()
            {
            /** [ OBJECT: WHMCS ] */
            $obj = $this->importClass(1);
            $file=$obj->getClient($this->globals['clientID']);
            unset($obj);
            
            /** [ ERROR: FILE NOT FOUND ] */
            if($file===false){globals::logActivity(globals::$lang['log']['invoice']['m3'],array('id'=>$this->globals['clientID'])); unset($file); return(false);}
            
            /** [ STORE: RECIPIENT DETAILS ] */
            $this->globals['recipient']['name']     = html_entity_decode($file['firstname'].' '.$file['lastname']);
            $this->globals['recipient']['company']  = html_entity_decode($file['companyname']);
            $this->globals['recipient']['address1'] = html_entity_decode($file['address1']);
            $this->globals['recipient']['address2'] = html_entity_decode($file['address2']);
            $this->globals['recipient']['city']     = html_entity_decode($file['city']);
            $this->globals['recipient']['state']    = html_entity_decode($file['state']);
            $this->globals['recipient']['postcode'] = html_entity_decode($file['postcode']);
            $this->globals['recipient']['country']  = html_entity_decode($file['countrycode']);      
                    
            /** [ RETURN: BOOLEAN ] */ 
            unset($file); return(true);
            }
        
        /** [ METHOD: MAIL ] */    
        private function mail()
            {
            /** [ OBJECT: WHMCS ] */
            $obj = $this->importClass(1);
            $file=$obj->getCustomField($this->globals['clientID']);
            $PDF=$obj->PDFInvoice($this->globals['invoiceID']);
            unset($obj);
            
            /** [ ERROR: PAPER INVOICE DISCARDED: CHECKBOX NOT SELECTED ] */
            if($file['value']!=='on'){globals::logActivity(globals::$lang['log']['invoice']['m9'],array('invoice_id'=>$this->globals['invoiceID'],'client_id'=>$this->globals['clientID'],'custom_field'=>globals::CUSTOM_CLIENT_FIELD_NAME)); unset($file,$PDF); return(false);}
            
            /** [ ERROR: PDF INVOICE NOT FOUND ] */
            if($PDF===false){globals::logActivity(globals::$lang['log']['invoice']['m8'],array('id'=>$this->globals['invoiceID'])); unset($file,$PDF); return(false);}
            
            /** [ OBJECT: MAIL ] */
            $obj = $this->importClass(2);
            $file=$obj->mail($this->globals['recipient'],$PDF,false);
            unset($obj,$PDF);
            
            /** [ ERROR: MAIL NOT SENT ] */
            if($file['status']===false)
                {
                /** [ METHOD: LOG ] */
                switch($file['errno'])
                    {
                    /** [ ERROR: CONNECTION FAILURE ] */
                    case '002': case '003': case '040': globals::logActivity(globals::$lang['log']['invoice']['m4'],array('id'=>$this->globals['invoiceID'],'errno'=>$file['errno'])); break;
                    
                    /** [ ERROR: INSUFFICIENT FUNDS ] */
                    case '032': globals::logActivity(globals::$lang['log']['invoice']['m5'],array('id'=>$this->globals['invoiceID'],'errno'=>$file['errno'])); break;
                    
                    /** [ ERROR: LICENSE FAILURE ] */
                    case 'LC001': globals::logActivity(globals::$lang['log']['license']['m1'],array('description'=>$file['description'],'code'=>$file['code'])); break;
                
                    /** [ ERROR: CATCH ALL ] */
                    default: globals::logActivity(globals::$lang['log']['invoice']['m6'],array('id'=>$this->globals['invoiceID'],'errno'=>$file['errno'])); break;
                    }

                /** [ RETURN: BOOLEAN ] */
                unset($file); return(false);
                }
            
            /** [ METHOD LOG ACTIVITY ] */    
            globals::logActivity(globals::$lang['log']['invoice']['m7'],array('id'=>$this->globals['invoiceID'],'reference'=>$file['transaction']['reference']));
            
            /** [ RETURN: BOOLEAN ] */
            unset($file); return(true);
            }
        }
?>